/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Diff of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.1 Revision 1.56
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.1 2004/11/24 16:36:38 johnm Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.56 2008/10/31 22:01:32 dsd Exp $
4# 4#
5# This eclass provides functions for querying the installed kernel 5# Original author: John Mylchreest <johnm@gentoo.org>
6# source version, selected kernel options etc. 6# Maintainer: kernel-misc@gentoo.org
7# 7#
8# Please direct your bugs to the current eclass maintainer :)
8 9
9ECLASS=linux-info 10# @ECLASS: linux-info.eclass
10INHERITED="$INHERITED $ECLASS" 11# @MAINTAINER:
12# kernel-misc@gentoo.org
13# @BLURB: eclass used for accessing kernel related information
14# @DESCRIPTION:
15# This eclass is used as a central eclass for accessing kernel
16# related information for sources already installed.
17# It is vital for linux-mod.eclass to function correctly, and is split
18# out so that any ebuild behaviour "templates" are abstracted out
19# using additional eclasses.
20
21# A Couple of env vars are available to effect usage of this eclass
22# These are as follows:
23
24# @ECLASS-VARIABLE: KERNEL_DIR
25# @DESCRIPTION:
26# A string containing the directory of the target kernel sources. The default value is
27# "/usr/src/linux"
28
29# @ECLASS-VARIABLE: CONFIG_CHECK
30# @DESCRIPTION:
31# A string containing a list of .config options to check for before
32# proceeding with the install.
33#
34# e.g.: CONFIG_CHECK="MTRR"
35#
36# You can also check that an option doesn't exist by
37# prepending it with an exclamation mark (!).
38#
39# e.g.: CONFIG_CHECK="!MTRR"
40#
41# To simply warn about a missing option, prepend a '~'.
42
43# @ECLASS-VARIABLE: ERROR_<CFG>
44# @DESCRIPTION:
45# A string containing the error message to display when the check against CONFIG_CHECK
46# fails. <CFG> should reference the appropriate option used in CONFIG_CHECK.
47#
48# e.g.: ERROR_MTRR="MTRR exists in the .config but shouldn't!!"
49
50# @ECLASS-VARIABLE: KBUILD_OUTPUT
51# @DESCRIPTION:
52# A string passed on commandline, or set from the kernel makefile. It contains the directory
53# which is to be used as the kernel object directory.
54
55# There are also a couple of variables which are set by this, and shouldn't be
56# set by hand. These are as follows:
57
58# @ECLASS-VARIABLE: KV_FULL
59# @DESCRIPTION:
60# A read-only variable. It's a string containing the full kernel version. ie: 2.6.9-gentoo-johnm-r1
61
62# @ECLASS-VARIABLE: KV_MAJOR
63# @DESCRIPTION:
64# A read-only variable. It's an integer containing the kernel major version. ie: 2
65
66# @ECLASS-VARIABLE: KV_MINOR
67# @DESCRIPTION:
68# A read-only variable. It's an integer containing the kernel minor version. ie: 6
69
70# @ECLASS-VARIABLE: KV_PATCH
71# @DESCRIPTION:
72# A read-only variable. It's an integer containing the kernel patch version. ie: 9
73
74# @ECLASS-VARIABLE: KV_EXTRA
75# @DESCRIPTION:
76# A read-only variable. It's a string containing the kernel EXTRAVERSION. ie: -gentoo
77
78# @ECLASS-VARIABLE: KV_LOCAL
79# @DESCRIPTION:
80# A read-only variable. It's a string containing the kernel LOCALVERSION concatenation. ie: -johnm
81
82# @ECLASS-VARIABLE: KV_DIR
83# @DESCRIPTION:
84# A read-only variable. It's a string containing the kernel source directory, will be null if
85# KERNEL_DIR is invalid.
86
87# @ECLASS-VARIABLE: KV_OUT_DIR
88# @DESCRIPTION:
89# A read-only variable. It's a string containing the kernel object directory, will be KV_DIR unless
90# KBUILD_OUTPUT is used. This should be used for referencing .config.
91
92# And to ensure all the weirdness with crosscompile
93inherit toolchain-funcs versionator
94
95EXPORT_FUNCTIONS pkg_setup
96
97DEPEND="kernel_linux? ( virtual/linux-sources )"
98RDEPEND=""
11 99
12# Overwritable environment Var's 100# Overwritable environment Var's
13# --------------------------------------- 101# ---------------------------------------
14KERNEL_DIR="${KERNEL_DIR:-/usr/src/linux}" 102KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}"
15 103
16 104
105# Bug fixes
106# fix to bug #75034
107case ${ARCH} in
108 ppc) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
109 ppc64) BUILD_FIXES="${BUILD_FIXES} TOUT=${T}/.tmp_gas_check";;
110esac
111
112# @FUNCTION: set_arch_to_kernel
113# @DESCRIPTION:
114# Set the env ARCH to match what the kernel expects.
115set_arch_to_kernel() { export ARCH=$(tc-arch-kernel); }
116# @FUNCTION: set_arch_to_portage
117# @DESCRIPTION:
118# Set the env ARCH to match what portage expects.
119set_arch_to_portage() { export ARCH=$(tc-arch); }
120
121# qeinfo "Message"
122# -------------------
123# qeinfo is a quiet einfo call when EBUILD_PHASE
124# should not have visible output.
125qout() {
126 local outputmsg type
127 type=${1}
128 shift
129 outputmsg="${@}"
130 case "${EBUILD_PHASE}" in
131 depend) unset outputmsg;;
132 clean) unset outputmsg;;
133 preinst) unset outputmsg;;
134 esac
135 [ -n "${outputmsg}" ] && ${type} "${outputmsg}"
136}
137
138qeinfo() { qout einfo "${@}" ; }
139qeerror() { qout eerror "${@}" ; }
17 140
18# File Functions 141# File Functions
19# --------------------------------------- 142# ---------------------------------------
20 143
21# getfilevar accepts 2 vars as follows: 144# @FUNCTION: getfilevar
22# getfilevar <VARIABLE> <CONFIGFILE> 145# @USAGE: variable configfile
23 146# @RETURN: the value of the variable
147# @DESCRIPTION:
148# It detects the value of the variable defined in the file configfile
24getfilevar() { 149getfilevar() {
25local ERROR 150local ERROR workingdir basefname basedname myARCH="${ARCH}"
26 ERROR=0 151 ERROR=0
27 152
28 [ -z "${1}" ] && ERROR=1 153 [ -z "${1}" ] && ERROR=1
29 [ -z "${2}" ] && ERROR=1
30 [ ! -f "${2}" ] && ERROR=1 154 [ ! -f "${2}" ] && ERROR=1
31 155
32 if [ "${ERROR}" = 1 ] 156 if [ "${ERROR}" = 1 ]
33 then 157 then
158 echo -e "\n"
34 eerror "getfilevar requires 2 variables, with the second a valid file." 159 eerror "getfilevar requires 2 variables, with the second a valid file."
35 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 160 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
36 else 161 else
37 grep -e "^$1" $2 | sed 's: = :=:' | cut -d= -f2- 162 workingdir="${PWD}"
38 fi 163 basefname="$(basename ${2})"
39} 164 basedname="$(dirname ${2})"
165 unset ARCH
40 166
41getfilevar_isset() { 167 cd "${basedname}"
168 echo -e "e:\\n\\t@echo \$(${1})\\ninclude ${basefname}" | \
169 make M="${S}" ${BUILD_FIXES} -s -f - 2>/dev/null
170 cd "${workingdir}"
171
172 ARCH=${myARCH}
173 fi
174}
175
176
177# @FUNCTION: linux_config_exists
178# @RETURN: true or false
179# @DESCRIPTION:
180# It returns true if .config exists otherwise false
181linux_config_exists() {
182 [ -s "${KV_OUT_DIR}/.config" ]
183}
184
185# @FUNCTION: require_configured_kernel
186# @DESCRIPTION:
187# This function verifies that the current kernel is configured (it checks against the existence of .config)
188# otherwise it dies.
189require_configured_kernel() {
190 if ! linux_config_exists; then
191 qeerror "Could not find a usable .config in the kernel source directory."
192 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
193 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
194 qeerror "it points to the necessary object directory so that it might find .config."
195 die "Kernel not configured; no .config found in ${KV_OUT_DIR}"
196 fi
197}
198
199# @FUNCTION: linux_chkconfig_present
200# @USAGE: option
201# @RETURN: true or false
202# @DESCRIPTION:
203# It checks that CONFIG_<option>=y or CONFIG_<option>=n is present in the current kernel .config
204linux_chkconfig_present() {
42local RESULT 205local RESULT
43 RESULT="$(getfilevar ${1} ${2})" 206 require_configured_kernel
207 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)"
44 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1 208 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
45} 209}
46 210
47getfilevar_ismodule() { 211# @FUNCTION: linux_chkconfig_module
212# @USAGE: option
213# @RETURN: true or false
214# @DESCRIPTION:
215# It checks that CONFIG_<option>=m is present in the current kernel .config
216linux_chkconfig_module() {
48local RESULT 217local RESULT
49 RESULT="$(getfilevar ${1} ${2})" 218 require_configured_kernel
219 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)"
50 [ "${RESULT}" = "m" ] && return 0 || return 1 220 [ "${RESULT}" = "m" ] && return 0 || return 1
51} 221}
52 222
53getfilevar_isbuiltin() { 223# @FUNCTION: linux_chkconfig_builtin
224# @USAGE: option
225# @RETURN: true or false
226# @DESCRIPTION:
227# It checks that CONFIG_<option>=y is present in the current kernel .config
228linux_chkconfig_builtin() {
54local RESULT 229local RESULT
55 RESULT="$(getfilevar ${1} ${2})" 230 require_configured_kernel
231 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)"
56 [ "${RESULT}" = "y" ] && return 0 || return 1 232 [ "${RESULT}" = "y" ] && return 0 || return 1
233}
234
235# @FUNCTION: linux_chkconfig_string
236# @USAGE: option
237# @RETURN: CONFIG_<option>
238# @DESCRIPTION:
239# It prints the CONFIG_<option> value of the current kernel .config (it requires a configured kernel).
240linux_chkconfig_string() {
241 require_configured_kernel
242 getfilevar "CONFIG_${1}" "${KV_OUT_DIR}/.config"
57} 243}
58 244
59# Versioning Functions 245# Versioning Functions
60# --------------------------------------- 246# ---------------------------------------
61 247
62# kernel_is returns true when the version is the same as the passed version 248# @FUNCTION: kernel_is
249# @USAGE: [-lt -gt -le -ge -eq] major_number [minor_number patch_number]
250# @RETURN: true or false
251# @DESCRIPTION:
252# It returns true when the current kernel version satisfies the comparison against the passed version.
253# -eq is the default comparison.
63# 254#
255# @CODE
64# For Example where KV = 2.6.9 256# For Example where KV = 2.6.9
65# kernel_is 2 4 returns false 257# kernel_is 2 4 returns false
66# kernel_is 2 returns true 258# kernel_is 2 returns true
67# kernel_is 2 6 returns true 259# kernel_is 2 6 returns true
68# kernel_is 2 6 8 returns false 260# kernel_is 2 6 8 returns false
69# kernel_is 2 6 9 returns true 261# kernel_is 2 6 9 returns true
70# 262# @CODE
263
71# got the jist yet? 264# got the jist yet?
72 265
73kernel_is() { 266kernel_is() {
74 # if we haven't determined the version yet, we need too. 267 # if we haven't determined the version yet, we need to.
75 get_version; 268 get_version
76 269 local operator test value x=0 y=0 z=0
77 local RESULT
78 RESULT=1
79
80 if [ -n "${1}" ]
81 then
82 [ "${1}" = "${KV_MAJOR}" ] && RESULT=0
83 fi
84
85 if [ -n "${2}" ]
86 then
87 RESULT=1
88 [ "${2}" = "${KV_MINOR}" ] && RESULT=0
89 fi
90
91 if [ -n "${3}" ]
92 then
93 RESULT=1
94 [ "${3}" = "${KV_PATCH}" ] && RESULT=0
95 fi
96 return ${RESULT}
97}
98 270
271 case ${1} in
272 lt) operator="-lt"; shift;;
273 gt) operator="-gt"; shift;;
274 le) operator="-le"; shift;;
275 ge) operator="-ge"; shift;;
276 eq) operator="-eq"; shift;;
277 *) operator="-eq";;
278 esac
279
280 for x in ${@}; do
281 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
282 value="${value}${x}"
283 z=$((${z} + 1))
284
285 case ${z} in
286 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
287 test="${test}${KV_MAJOR}";;
288 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
289 test="${test}${KV_MINOR}";;
290 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
291 test="${test}${KV_PATCH}";;
292 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
293 esac
294 done
295
296 [ ${test} ${operator} ${value} ] && return 0 || return 1
297}
298
299get_localversion() {
300 local lv_list i x
301
302 # ignore files with ~ in it.
303 for i in $(ls ${1}/localversion* 2>/dev/null); do
304 [[ -n ${i//*~*} ]] && lv_list="${lv_list} ${i}"
305 done
306
307 for i in ${lv_list}; do
308 x="${x}$(<${i})"
309 done
310 x=${x/ /}
311 echo ${x}
312}
313
314# @FUNCTION: get_version
315# @DESCRIPTION:
316# It gets the version of the kernel inside KERNEL_DIR and populates the KV_FULL variable
317# (if KV_FULL is already set it does nothing).
318#
319# The kernel version variables (KV_MAJOR, KV_MINOR, KV_PATCH, KV_EXTRA and KV_LOCAL) are also set.
320#
321# The KV_DIR is set using the KERNEL_DIR env var, the KV_DIR_OUT is set using a valid
322# KBUILD_OUTPUT (in a decreasing priority list, we look for the env var, makefile var or the
323# symlink /lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build).
99get_version() { 324get_version() {
325 local kbuild_output
326
100 # no need to execute this twice assuming KV_FULL is populated. 327 # no need to execute this twice assuming KV_FULL is populated.
101 # we can force by unsetting KV_FULL 328 # we can force by unsetting KV_FULL
102 if [ -n "${KV_FULL}" ] 329 [ -n "${KV_FULL}" ] && return 0
103 then
104 # Lets keep this quiet eh?
105 # einfo "\${KV_FULL} is already set. Not running get_version again"
106 return
107 fi
108 330
109 # if we dont know KV_FULL, then we need too. 331 # if we dont know KV_FULL, then we need too.
110 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR 332 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR
111 unset KV_DIR 333 unset KV_DIR
112 334
113 # KV_DIR will contain the full path to the sources directory we should use 335 # KV_DIR will contain the full path to the sources directory we should use
114 einfo "Determining the location of the kernel source code" 336 qeinfo "Determining the location of the kernel source code"
115 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})" 337 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})"
116 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}" 338 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}"
117 339
118 if [ -z "${KV_DIR}" ] 340 if [ -z "${KV_DIR}" ]
119 then 341 then
120 eerror "Unable to find kernel sources at ${KERNEL_DIR}" 342 qeerror "Unable to find kernel sources at ${KERNEL_DIR}"
121 die 343 qeinfo "This package requires Linux sources."
344 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then
345 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, "
346 qeinfo "(or the kernel you wish to build against)."
347 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location"
348 else
349 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against."
122 fi 350 fi
123 351 return 1
352 fi
353
354 qeinfo "Found kernel source directory:"
355 qeinfo " ${KV_DIR}"
356
357 if [ ! -s "${KV_DIR}/Makefile" ]
358 then
359 qeerror "Could not find a Makefile in the kernel source directory."
360 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources"
361 return 1
362 fi
363
364 # OK so now we know our sources directory, but they might be using
365 # KBUILD_OUTPUT, and we need this for .config and localversions-*
366 # so we better find it eh?
367 # do we pass KBUILD_OUTPUT on the CLI?
368 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
369
370 # And if we didn't pass it, we can take a nosey in the Makefile
371 kbuild_output="$(getfilevar KBUILD_OUTPUT ${KV_DIR}/Makefile)"
372 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
373
124 # And contrary to existing functions I feel we shouldn't trust the 374 # And contrary to existing functions I feel we shouldn't trust the
125 # directory name to find version information as this seems insane. 375 # directory name to find version information as this seems insane.
126 # so we parse ${KV_DIR}/Makefile 376 # so we parse ${KV_DIR}/Makefile
127 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)" 377 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)"
128 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)" 378 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)"
129 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)" 379 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)"
130 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)" 380 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)"
381
382 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
383 then
384 qeerror "Could not detect kernel version."
385 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
386 return 1
387 fi
388
131 # and in newer versions we can also pull LOCALVERSION if it is set. 389 # and in newer versions we can also pull LOCALVERSION if it is set.
132 KV_LOCAL="$(cat ${KV_DIR}/localversion* 2>/dev/null)$(getfilevar CONFIG_LOCALVERSION ${KV_DIR}/.config | sed 's:"::g')" 390 # but before we do this, we need to find if we use a different object directory.
133 391 # This *WILL* break if the user is using localversions, but we assume it was
392 # caught before this if they are.
393 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}" == "$(uname -r)" ] && \
394 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build}"
395
396 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})"
397 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
398 if [ -n "${KV_OUT_DIR}" ];
399 then
400 qeinfo "Found kernel object directory:"
401 qeinfo " ${KV_OUT_DIR}"
402
403 KV_LOCAL="$(get_localversion ${KV_OUT_DIR})"
404 fi
405 # and if we STILL have not got it, then we better just set it to KV_DIR
406 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
407
408 KV_LOCAL="${KV_LOCAL}$(get_localversion ${KV_DIR})"
409 if linux_config_exists; then
410 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)"
411 KV_LOCAL="${KV_LOCAL//\"/}"
412
413 # For things like git that can append extra stuff:
414 [ -e ${KV_DIR}/scripts/setlocalversion ] &&
415 linux_chkconfig_builtin LOCALVERSION_AUTO &&
416 KV_LOCAL="${KV_LOCAL}$(sh ${KV_DIR}/scripts/setlocalversion ${KV_DIR})"
417 fi
418
134 # And we should set KV_FULL to the full expanded version 419 # And we should set KV_FULL to the full expanded version
135 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}" 420 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
136 421
137 if [ -z "${KV_FULL}" ] 422 qeinfo "Found sources for kernel version:"
138 then 423 qeinfo " ${KV_FULL}"
139 eerror "We are unable to find a usable kernel source tree in ${KV_DIR}" 424
140 eerror "Please check a kernel source exists in this directory." 425 return 0
141 die 426}
427
428# @FUNCTION: get_running_version
429# @DESCRIPTION:
430# It gets the version of the current running kernel and the result is the same as get_version() if the
431# function can find the sources.
432get_running_version() {
433 KV_FULL=$(uname -r)
434
435 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then
436 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source)
437 unset KV_FULL
438 get_version
439 return $?
440 elif [[ -f ${ROOT}/lib/modules/${KV_FULL}/build/Makefile ]]; then
441 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/build)
442 unset KV_FULL
443 get_version
444 return $?
142 else 445 else
143 einfo "Found kernel source directory:" 446 KV_MAJOR=$(get_version_component_range 1 ${KV_FULL})
144 einfo " ${KV_DIR}" 447 KV_MINOR=$(get_version_component_range 2 ${KV_FULL})
145 einfo "with sources for kernel version:" 448 KV_PATCH=$(get_version_component_range 3- ${KV_FULL})
146 einfo " ${KV_FULL}" 449 KV_PATCH=${KV_PATCH//-*}
450 [[ -n ${KV_FULL#*-} ]] && [[ -n ${KV_FULL//${KV_FULL#*-}} ]] \
451 && KV_EXTRA="-${KV_FULL#*-}"
147 fi 452 fi
453 return 0
148} 454}
149
150
151 455
152 456
153# ebuild check functions 457# ebuild check functions
154# --------------------------------------- 458# ---------------------------------------
155 459
460# @FUNCTION: check_kernel_built
461# @DESCRIPTION:
462# This function verifies that the current kernel sources have been already prepared otherwise it dies.
156check_kernel_built() { 463check_kernel_built() {
157 # if we haven't determined the version yet, we need too. 464 # if we haven't determined the version yet, we need to
465 require_configured_kernel
158 get_version; 466 get_version
159 467
160 if [ ! -f "${KV_DIR}/System.map" ] 468 if [ ! -f "${KV_OUT_DIR}/include/linux/version.h" ]
161 then 469 then
162 eerror "These sources have not yet been compiled." 470 eerror "These sources have not yet been prepared."
163 eerror "We cannot build against an uncompiled tree." 471 eerror "We cannot build against an unprepared tree."
164 eerror "To resolve this, please type the following:" 472 eerror "To resolve this, please type the following:"
165 eerror 473 eerror
166 eerror "# cd ${KV_DIR}" 474 eerror "# cd ${KV_DIR}"
167 eerror "# make oldconfig" 475 eerror "# make oldconfig"
168 eerror "# make bzImage modules modules_install" 476 eerror "# make modules_prepare"
169 eerror 477 eerror
170 eerror "Then please try merging this module again." 478 eerror "Then please try merging this module again."
171 die "Kernel sources need compiling first" 479 die "Kernel sources need compiling first"
172 fi 480 fi
173} 481}
174 482
483# @FUNCTION: check_modules_supported
484# @DESCRIPTION:
485# This function verifies that the current kernel support modules (it checks CONFIG_MODULES=y) otherwise it dies.
175check_modules_supported() { 486check_modules_supported() {
176 # if we haven't determined the version yet, we need too. 487 # if we haven't determined the version yet, we need too.
488 require_configured_kernel
177 get_version; 489 get_version
178 490
179 getfilevar_isset CONFIG_MODULES ${KV_DIR}/.config 491 if ! linux_chkconfig_builtin "MODULES"
180 if [ "$?" != 0 ]
181 then 492 then
182 eerror "These sources do not support loading external modules." 493 eerror "These sources do not support loading external modules."
183 eerror "to be able to use this module please enable \"Loadable modules support\"" 494 eerror "to be able to use this module please enable \"Loadable modules support\""
184 eerror "in your kernel, recompile and then try merging this module again." 495 eerror "in your kernel, recompile and then try merging this module again."
496 die "No support for external modules in ${KV_FULL} config"
497 fi
498}
499
500# @FUNCTION: check_extra_config
501# @DESCRIPTION:
502# It checks the kernel config options specified by CONFIG_CHECK. It dies only when a required config option (i.e.
503# the prefix ~ is not used) doesn't satisfy the directive.
504check_extra_config() {
505 local config negate die error reworkmodulenames
506 local soft_errors_count=0 hard_errors_count=0 config_required=0
507
508 # if we haven't determined the version yet, we need to
509 get_version
510
511 # Determine if we really need a .config. The only time when we don't need
512 # one is when all of the CONFIG_CHECK options are prefixed with "~".
513 for config in ${CONFIG_CHECK}
514 do
515 if [[ "${config:0:1}" != "~" ]]; then
516 config_required=1
517 break
518 fi
519 done
520
521 if [[ ${config_required} == 0 ]]; then
522 # In the case where we don't require a .config, we can now bail out
523 # if the user has no .config as there is nothing to do. Otherwise
524 # code later will cause a failure due to missing .config.
525 if ! linux_config_exists; then
526 return 0
527 fi
528 else
529 require_configured_kernel
530 fi
531
532 einfo "Checking for suitable kernel configuration options..."
533
534 for config in ${CONFIG_CHECK}
535 do
536 # if we specify any fatal, ensure we honor them
537 die=1
538 error=0
539 negate=0
540 reworkmodulenames=0
541
542 if [[ ${config:0:1} == "~" ]]; then
543 die=0
544 config=${config:1}
545 elif [[ ${config:0:1} == "@" ]]; then
546 die=0
547 reworkmodulenames=1
548 config=${config:1}
549 fi
550 if [[ ${config:0:1} == "!" ]]; then
551 negate=1
552 config=${config:1}
553 fi
554
555 if [[ ${negate} == 1 ]]; then
556 linux_chkconfig_present ${config} && error=2
557 elif [[ ${reworkmodulenames} == 1 ]]; then
558 local temp_config="${config//*:}" i n
559 config="${config//:*}"
560 if linux_chkconfig_present ${config}; then
561 for i in ${MODULE_NAMES}; do
562 n="${i//${temp_config}}"
563 [[ -z ${n//\(*} ]] && \
564 MODULE_IGNORE="${MODULE_IGNORE} ${temp_config}"
565 done
566 error=2
567 fi
568 else
569 linux_chkconfig_present ${config} || error=1
570 fi
571
572 if [[ ${error} > 0 ]]; then
573 local report_func="eerror" local_error
574 local_error="ERROR_${config}"
575 local_error="${!local_error}"
576
577 if [[ -z "${local_error}" ]]; then
578 # using old, deprecated format.
579 local_error="${config}_ERROR"
580 local_error="${!local_error}"
581 fi
582 if [[ ${die} == 0 && -z "${local_error}" ]]; then
583 #soft errors can be warnings
584 local_error="WARNING_${config}"
585 local_error="${!local_error}"
586 if [[ -n "${local_error}" ]] ; then
587 report_func="ewarn"
588 fi
589 fi
590
591 if [[ -z "${local_error}" ]]; then
592 [[ ${error} == 1 ]] \
593 && local_error="is not set when it should be." \
594 || local_error="should not be set. But it is."
595 local_error="CONFIG_${config}:\t ${local_error}"
596 fi
597 if [[ ${die} == 0 ]]; then
598 ${report_func} " ${local_error}"
599 soft_errors_count=$[soft_errors_count + 1]
600 else
601 ${report_func} " ${local_error}"
602 hard_errors_count=$[hard_errors_count + 1]
603 fi
604 fi
605 done
606
607 if [[ ${hard_errors_count} > 0 ]]; then
608 eerror "Please check to make sure these options are set correctly."
609 eerror "Failure to do so may cause unexpected problems."
610 eerror "Once you have satisfied these options, please try merging"
611 eerror "this package again."
612 die "Incorrect kernel configuration options"
613 elif [[ ${soft_errors_count} > 0 ]]; then
614 ewarn "Please check to make sure these options are set correctly."
615 ewarn "Failure to do so may cause unexpected problems."
616 else
617 eend 0
185 fi 618 fi
186} 619}
187 620
188check_zlibinflate() { 621check_zlibinflate() {
189 # if we haven't determined the version yet, we need too. 622 # if we haven't determined the version yet, we need to
623 require_configured_kernel
190 get_version; 624 get_version
191 625
192 # although I restructured this code - I really really really dont support it! 626 # although I restructured this code - I really really really dont support it!
193 627
194 # bug #27882 - zlib routines are only linked into the kernel 628 # bug #27882 - zlib routines are only linked into the kernel
195 # if something compiled into the kernel calls them 629 # if something compiled into the kernel calls them
196 # 630 #
197 # plus, for the cloop module, it appears that there's no way 631 # plus, for the cloop module, it appears that there's no way
198 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS 632 # to get cloop.o to include a static zlib if CONFIG_MODVERSIONS
199 # is on 633 # is on
200 634
201local INFLATE 635 local INFLATE
202local DEFLATE 636 local DEFLATE
203 637
204 einfo "Determining the usability of ZLIB_INFLATE support in your kernel" 638 einfo "Determining the usability of ZLIB_INFLATE support in your kernel"
205 639
206 ebegin "checking ZLIB_INFLATE" 640 ebegin "checking ZLIB_INFLATE"
207 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config 641 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config
208 eend $? 642 eend $?
209 [ "$?" != 0 ] && die 643 [ "$?" != 0 ] && die
210 644
211 ebegin "checking ZLIB_DEFLATE" 645 ebegin "checking ZLIB_DEFLATE"
212 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config 646 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config
213 eend $? 647 eend $?
214 [ "$?" != 0 ] && die 648 [ "$?" != 0 ] && die
215 649
216
217 local LINENO_START 650 local LINENO_START
218 local LINENO_END 651 local LINENO_END
219 local SYMBOLS 652 local SYMBOLS
220 local x 653 local x
221 654
222 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)" 655 LINENO_END="$(grep -n 'CONFIG_ZLIB_INFLATE y' ${KV_DIR}/lib/Config.in | cut -d : -f 1)"
223 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)" 656 LINENO_START="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | grep -n 'if \[' | tail -n 1 | cut -d : -f 1)"
224 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START )) 657 (( LINENO_AMOUNT = $LINENO_END - $LINENO_START ))
225 (( LINENO_END = $LINENO_END - 1 )) 658 (( LINENO_END = $LINENO_END - 1 ))
226 SYMBOLS="$(head -n $LINENO_END ${KERNEL_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')" 659 SYMBOLS="$(head -n $LINENO_END ${KV_DIR}/lib/Config.in | tail -n $LINENO_AMOUNT | sed -e 's/^.*\(CONFIG_[^\" ]*\).*/\1/g;')"
227 660
228 # okay, now we have a list of symbols 661 # okay, now we have a list of symbols
229 # we need to check each one in turn, to see whether it is set or not 662 # we need to check each one in turn, to see whether it is set or not
230 for x in $SYMBOLS ; do 663 for x in $SYMBOLS ; do
231 if [ "${!x}" = "y" ]; then 664 if [ "${!x}" = "y" ]; then
232 # we have a winner! 665 # we have a winner!
233 einfo "${x} ensures zlib is linked into your kernel - excellent" 666 einfo "${x} ensures zlib is linked into your kernel - excellent"
234 return 0 667 return 0
235 fi 668 fi
236 done 669 done
237 670
238 eerror 671 eerror
239 eerror "This kernel module requires ZLIB library support." 672 eerror "This kernel module requires ZLIB library support."
240 eerror "You have enabled zlib support in your kernel, but haven't enabled" 673 eerror "You have enabled zlib support in your kernel, but haven't enabled"
241 eerror "enabled any option that will ensure that zlib is linked into your" 674 eerror "enabled any option that will ensure that zlib is linked into your"
242 eerror "kernel." 675 eerror "kernel."
252 eerror "Please remember to recompile and install your kernel, and reboot" 685 eerror "Please remember to recompile and install your kernel, and reboot"
253 eerror "into your new kernel before attempting to load this kernel module." 686 eerror "into your new kernel before attempting to load this kernel module."
254 687
255 die "Kernel doesn't include zlib support" 688 die "Kernel doesn't include zlib support"
256} 689}
690
691################################
692# Default pkg_setup
693# Also used when inheriting linux-mod to force a get_version call
694# @FUNCTION: linux-info_pkg_setup
695# @DESCRIPTION:
696# Force a get_version() call when inherited from linux-mod.eclass and then check if the kernel is configured
697# to support the options specified in CONFIG_CHECK (if not null)
698linux-info_pkg_setup() {
699 get_version || die "Unable to calculate Linux Kernel version"
700
701 if kernel_is 2 4; then
702 if [ "$( gcc-major-version )" -eq "4" ] ; then
703 echo
704 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with"
705 ewarn "linux-2.4 (or modules building against a linux-2.4 kernel)!"
706 echo
707 ewarn "Either switch to another gcc-version (via gcc-config) or use a"
708 ewarn "newer kernel that supports gcc-4."
709 echo
710 ewarn "Also be aware that bugreports about gcc-4 not working"
711 ewarn "with linux-2.4 based ebuilds will be closed as INVALID!"
712 echo
713 epause 10
714 fi
715 fi
716
717 [ -n "${CONFIG_CHECK}" ] && check_extra_config;
718}

Legend:
Removed from v.1.1  
changed lines
  Added in v.1.56

  ViewVC Help
Powered by ViewVC 1.1.20